wlayton found a bad search and replace for ibex -> intrepid - thanks!
[OpenSRF.git] / src / extras / Makefile.install
1 # ---------------------------------------------------------------------
2 # Author: Bill Erickson <erickson@esilibrary.com>
3 #
4 # Makefile to install prerequisites for OpenSRF
5 #
6 # Currently supports Debian (etch/lenny), Ubuntu (gutsy/hardy/intrepid), and Gentoo.
7 # Working towards support of CentOS 5 / RHEL 5.
8 # Installs Perl prereqs, libjs with Perl wrapper
9 #
10 # usage:
11 #       make -f Makefile.install debian-etch
12 #       - or -
13 #       make -f Makefile.install debian-lenny
14 #       - or -
15 #       make -f Makefile.install ubuntu-gutsy
16 #       - or -
17 #       make -f Makefile.install ubuntu-hardy
18 #       - or -
19 #       make -f Makefile.install ubuntu-intrepid
20 #       - or -
21 #       make -f Makefile.install centos
22 #       - or -
23 #       make -f Makefile.install rhel
24 #       - or -
25 #       make -f Makefile.install gentoo
26 #
27 # Notes:
28 #
29 #       This makefile has been tested much more with Ubuntu and Debian than
30 #   CentOS, Gentoo, or RHEL.
31 #
32 #       Gentoo (especially amd64) requires a good bit of masked package
33 #       mangling for some packages.  These are not documented here because
34 #       they will continue to evolve
35 #
36 # ---------------------------------------------------------------------
37
38 # Make any assumptions about the shell being used explicit
39 SHELL=/bin/bash 
40
41 # XXX
42 # Gentoo needs explicit versions on many of these packages
43 # to simulate a "blessed" set of packages
44
45 # ejabberd is not packaged on CentOS/RHEL, so we have to
46 # download the installable package from the source
47 EJABBERD_VER=2.0.2
48 EJABBERD_PKG=ejabberd-2.0.2_2-linux-x86-installer.bin
49 EJABBERD_PKG_x64=ejabberd-2.0.2_2-linux-x86_64-installer.bin
50 EJABBERD_HOST=http://www.process-one.net/downloads/ejabberd
51
52 # libmemcache is not packaged on CentOS/RHEL
53 LIBMEMCACHE=libmemcache-1.4.0.rc2
54 LIBMEMCACHE_HOST=http://people.freebsd.org/~seanc/libmemcache/
55
56 # XML::LibXSLT fails due to old libxslt
57 XSLT=libxslt-1.1.22
58 XSLT_HOST=ftp://ftp.gnome.org/pub/GNOME/sources/libxslt/1.1
59
60 # libxslt depends on a newer version of libxml2:
61 XML2=libxml2-2.6.30.tar.gz
62 XML2_HOST=ftp://ftp.gnome.org/pub/GNOME/sources/libxml2/2.6
63
64 APT_TOOL=aptitude
65
66 # Debian dependencies
67 DEBS =  \
68         apache2-mpm-prefork\
69         apache2-prefork-dev\
70         autoconf\
71         automake\
72         build-essential\
73         ejabberd\
74         less\
75         libapache2-mod-perl2\
76         libcache-memcached-perl\
77         libclass-dbi-abstractsearch-perl\
78         libclass-dbi-sqlite-perl\
79         liberror-perl\
80         libexpat1-dev\
81         libfile-find-rule-perl\
82         libfreezethaw-perl\
83         liblog-log4perl-perl\
84         libmemcache-dev\
85         libmodule-build-perl\
86         libnet-jabber-perl\
87         libperl-dev\
88         libreadline5-dev\
89         librpc-xml-perl\
90         libtemplate-perl\
91         libtest-pod-perl\
92         libtie-ixhash-perl\
93         libtool\
94         libuniversal-require-perl\
95         libunix-syslog-perl\
96         libwww-perl\
97         libxml2-dev\
98         libxml-libxml-perl\
99         libxml-libxslt-perl\
100         libxml-simple-perl\
101         libxslt1-dev\
102         memcached\
103         ntpdate\
104         psmisc\
105         python-dev\
106         python-libxml2\
107         python-setuptools
108
109 CENTOS = \
110         apr-util-devel \
111         autoconf \
112         automake \
113         gcc \
114         gdbm-devel \
115         httpd-devel \
116         less \
117         libtool \
118         libxml2-devel \
119         libxslt-devel \
120         make \
121         mod_perl \
122         mod_ssl \
123         ncurses \
124         ncurses-devel \
125         ntp \
126         perl-DBI \
127         perl-XML-LibXML \
128         perl-XML-Simple \
129         perl-libwww-perl \
130         psmisc \
131         python-devel \
132         python-setuptools\
133         readline-devel \
134         wget
135
136 # Some of these packages have stupid bugs in their test suites
137 # that are simply too painful to workaround
138 CENTOS_PERL_NOTEST = \
139         RPC::XML
140
141 CENTOS_PERL_LOCAL = \
142         XML-LibXSLT
143
144 CENTOS_PERL = \
145         Cache::Memcached \
146         Class::DBI::AbstractSearch \
147         Class::DBI::SQLite \
148         Error \
149         File::Find::Rule \
150         FreezeThaw \
151         Log::Log4perl \
152         Net::Jabber \
153         Template \
154         Test::Pod \
155         Tie::IxHash \
156         Unix::Syslog \
157         UNIVERSAL::require \
158         XML::LibXSLT
159
160 GENTOOS = \
161         vim\
162         ntp\
163         memcached\
164         libmemcache\
165         net-misc/telnet-bsd\
166         app-portage/gentoolkit\
167         gsasl\
168         ejabberd\
169         mod_perl\
170         net-fs/nfs-utils\
171         dev-libs/apr\
172         dev-perl/Cache-Memcached\
173         dev-perl/DBI\
174         dev-perl/Log-Log4perl\
175         dev-perl/Unix-Syslog\
176         dev-perl/XML-LibXML\
177         dev-perl/XML-LibXSLT\
178         dev-perl/XML-Simple\
179         dev-perl/Net-Jabber\
180         dev-perl/libwww-perl\
181         dev-perl/Template-Toolkit\
182         dev-perl/Error\
183         dev-perl/Tie-IxHash\
184         dev-perl/FreezeThaw
185
186 GENTOO_RC = \
187         ejabberd\
188         memcached\
189         portmap
190
191 GENTOO_PERL = \
192         Class::DBI::AbstractSearch\
193         UNIVERSAL::require
194
195 DEB_APACHE_MODS = \
196         ssl
197
198 EXTRA_DEBS = \
199         libdatetime-format-iso8601-perl \
200         libjson-xs-perl \
201         libnet-server-perl
202
203 # generic CPAN modules:
204 #   * DateTime::Format::ISO8601 is packaged by both Debian Lenny and Ubuntu Intrepid
205 #   * JSON::XS is packaged by both Debian Lenny and Ubuntu Intrepid
206 #   * libnet-server-perl 0.97 is packaged on Debian Lenny and Ubuntu Intrepid
207 #     - is there a specific need for 0.90?
208 CPAN_MODULES = \
209         DateTime::Format::ISO8601 \
210         RHANDOM/Net-Server-0.90.tar.gz \
211         JSON::XS
212
213 #   libxml-libxml-perl on Debian Lenny and Ubuntu Intrepid is 1.66, which
214 #   has broken namespace handling. so we still need to install these from
215 #   CPAN. *sigh*
216 CPAN_MODULES_XML = \
217         XML::LibXML \
218         XML::LibXSLT
219
220 # generic CPAN modules to force
221 CPAN_MODULES_FORCE = \
222         TMTM/Class-DBI-0.96.tar.gz
223
224 # ----------------------------------------------------------------------------
225
226 all: 
227         @echo "please specify an OS" && exit 0
228
229
230 centos: install_centos_rpms install_ejabberd install_libmemcache install install_libxml2 install_libxslt install_centos_perl create_ld_local
231
232 debian-etch: generic_debian etch
233 debian-lenny: generic_debian lenny
234 etch: install_cpan
235 lenny: install_extra_debs
236 generic_debian: install_debs install_cpan_force install_cpan_xml debian_sys_config
237
238 gentoo: install_gentoos install_gentoo_rc install_gentoo_perl install
239
240 rhel: centos
241
242 ubuntu-gutsy: generic_ubuntu hardy 
243 ubuntu-hardy: generic_ubuntu hardy
244 ubuntu-intrepid: generic_ubuntu intrepid
245 hardy: install_cpan
246 intrepid: install_extra_debs
247 generic_ubuntu: generic_debian
248
249 # - COMMON TARGETS ---------------------------------------------------------
250
251 # Install the CPAN modules
252 install_cpan: 
253         for m in $(CPAN_MODULES); do perl -MCPAN -e "install \"$$m\";"; done
254
255 # Install CPAN modules that need to be forced
256 install_cpan_force: 
257         for m in $(CPAN_MODULES_FORCE); do perl -MCPAN -e "CPAN::Shell->force(qw#install $$m#);"; done
258
259 # Install the CPAN XML modules
260 install_cpan_xml: 
261         for m in $(CPAN_MODULES_XML); do perl -MCPAN -e "install \"$$m\";"; done
262
263 # Install ejabberd from official project installer binary
264 install_ejabberd:    
265         if [ ! -f $(EJABBERD_PKG).gz ]; then wget $(EJABBERD_HOST)/$(EJABBERD_VER)/$(EJABBERD_PKG).gz; fi;
266         gunzip $(EJABBERD_PKG).gz
267         chmod u+x $(EJABBERD_PKG).gz
268         ./$(EJABBERD_PKG) --mode unattended --prefix /opt/ejabberd --adminpw opensrf
269
270 # Install libmemcache from the official project source
271 install_libmemcache:
272         if [ ! -d $(LIBMEMCACHE) ]; then wget $(LIBMEMCACHE_HOST)/$(LIBMEMCACHE).tar.bz2; fi;
273         tar xjf $(LIBMEMCACHE).tar.bz2
274         cd $(LIBMEMCACHE) && ./configure && make && make install
275
276 # Install a newer version of libxslt
277 install_libxslt:    
278         if [ ! -d $(XSLT) ]; then wget $(XSLT_HOST)/$(XSLT).tar.gz; fi;
279         tar xzf $(XSLT).tar.gz
280         cd $(XSLT) && ./configure --with-libxml-prefix=/usr/local && make && make install
281
282 # Install a newer version of libxml2
283 install_libxml2:    
284         if [ ! -d $(XML2) ]; then wget $(XML2_HOST)/$(XML2).tar.gz; fi;
285         tar xzf $(XML2).tar.gz
286         cd $(XML2) && ./configure && make && make install
287
288 clean:
289         make -C $(LIBJS_PERL) clean
290         make -C $(XML2) clean
291         make -C $(XSLT) clean
292         make -f Makefile.ref -C js/src/ clean
293
294
295 # ------------------------------------------------------------------
296 # - DEBIAN ---------------------------------------------------------
297
298 debian_sys_config: 
299         # link the apache modules in
300         for m in $(DEB_APACHE_MODS); do a2enmod $$m; done;
301
302         # adds a placeholder module so apxs will be happy
303         if [ ! "$$(grep mod_placeholder /etc/apache2/httpd.conf)" ]; then \
304                 echo -e "#\n#LoadModule mod_placeholder /usr/lib/apache2/modules/mod_placeholder.so" \
305                         >> /etc/apache2/httpd.conf; \
306         fi;
307
308 # Install the debian-specific dependencies
309 install_debs:
310         $(APT_TOOL) install $(DEBS)
311
312 # Install the debian-specific dependencies for more modern distros
313 install_extra_debs:
314         $(APT_TOOL) install $(EXTRA_DEBS)
315
316 # ------------------------------------------------------------------
317 # - GENTOO ---------------------------------------------------------
318
319 install_gentoos:
320         emerge -n $(GENTOOS)
321
322 install_gentoo_rc:
323         for m in $(GENTOO_RC); do rc-update add $$m default; done;
324
325 install_gentoo_perl:
326         for m in $(GENTOO_PERL); do perl -MCPAN -e "install \"$$m\";"; done
327
328 # ------------------------------------------------------------------
329
330 # CENTOS
331 install_centos_rpms:
332         yum -y install $(CENTOS)
333
334 install_centos_perl:
335         for m in $(CENTOS_PERL_FORCE); do perl -MCPAN -e "CPAN::Shell->force(qw#install $$m#);"; done
336         for m in $(CENTOS_PERL); do perl -MCPAN -e "install \"$$m\";"; done
337         for m in $(CENTOS_PERL_VERSION); do perl -MCPAN -e "CPAN::Shell->install \"$$m\";"; done
338         for m in $(CENTOS_PERL_NOTEST); do perl -MCPAN -e "CPAN::Shell->notest('install', \"$$m\";"; done
339         for m in $(CENTOS_PERL_LOCAL); do LD_LIBRARY_PATH=/usr/local/lib:/usr/lib:/lib perl -MCPAN -e "install \"$$m\";"; done
340
341 # We need to add /usr/local/lib to the ldconfig list of directories on CentOS,
342 # if it is not already there
343 create_ld_local:
344         if [ "$$(ldconfig -v 2> /dev/null | grep '^/usr/local/lib' | wc -l)" -eq 0 ]; then \
345                 echo '/usr/local/lib' > /etc/ld.so.conf.d/local.conf; \
346                 ldconfig; \
347         fi;
348
349 # vim:noet:sw=4:ts=4: